const express = require('express');
const db = require('./db');
const func = require('./func');
const user = require('./user');
const obj = require('./object');
const proj = require('./project');
const vars = require('./vars');
const cookieParser = require('cookie-parser');

// const {
//     response,
//     request
// } = require('express');
// const { escapeSelector } = require('jquery');
// const { name } = require('ejs');
// const { stringify } = require('uuid');
// const createApplication = require('express/lib/express');
// const { render } = require('express/lib/response');
const app = express();

// const {
//     pathToFileURL
// } = require("url");
// const { strict } = require('assert');
// const { log } = require('console');
// const { mainModule } = require('process');
// const { name } = require('ejs');

const maxRequestBodySize = '20mb';
app.set('view engine', 'ejs');
app.use(express.urlencoded({
    extended: false,
    limit: maxRequestBodySize
}));
app.use(express.static('public'));
app.use(cookieParser());


app.post('/back_login', (req, res) => {
    try {
        let inp = req.body;
        let cook = req.cookies;
        user.login(inp,cook,res);
    } catch (error) {
        func.log("router login error - "+error);
    }
});

app.post('/reg_user', (req, res) => {
    try{
        let inp = req.body;
        let cook = req.cookies;
        user.reg(inp,cook,res)
    } catch (error) {
        func.log("router registration error - "+error);
    }
})

app.post("/sid_log",(req,res) =>{
    try{
        let inp = req.body;
        let cook = req.cookies;
        user.sid_log(inp,cook,res,req);
    } catch (error) {
        func.log("router sid logging in error - "+error);
    }
})

app.post("/get_sid" , (req,res) =>{
    try{
        let inp = req.body;
        let sid = func.get_uuid();
        res.cookie("sid",sid,{maxAge:(vars.week),path:"/;SameSite=Strict"});
        res.send({out:"good"});
    } catch (error) {
        func.log("router sid getting error - "+error);
    }
});


app.post("/clear_sid" , (req,res) =>{
    try{
        let inp = req.body;
        let cook = req.cookies;
        user.clear_sid(inp,cook,res);
    } catch (error) {
        func.log("router sid clearing error - "+error);
    }
});

app.post("/get_cr_uuid", (req,res) => {
    try{
        let inp = req.body;
        let cook = req.cookies;
        func.sid(cook,res,()=>{
            user.get_cr(inp,cook,res);
        })
    } catch (error) {
        func.log("router getting user information by uuid error - "+error);
    }
})

app.post("/save_proj", (req,res) => {
    try{
        let inp = req.body;
        let cook = req.cookies;
        func.sid(cook,res,()=>{
            proj.save(inp,cook,res);
        })
    } catch (error) {
        func.log("router project saving error - "+error);
    }
})

app.post("/load_proj", (req,res) => {
    try{
        let inp = req.body;
        let cook = req.cookies;
        func.sid(cook,res,()=>{
            proj.load(inp,cook,res);
        })
    } catch (error) {
        func.log("router project loading error - "+error);
    }
})

app.post("/get_projs", (req,res) => {
    try{
        let inp = req.body;
        let cook = req.cookies;
        func.sid(cook,res,()=>{
            proj.loads(inp,cook,res);
        })
    } catch (error) {
        func.log("router user projects getting error - "+error);
    }
})

app.post("/new_obj", (req,res) => {
    try{
        let inp = req.body;
        let cook = req.cookies;
        func.sid(cook,res,()=>{
            obj.new(inp,cook,res);
        })
    } catch (error) {
        func.log("router object creating error - "+error);
    }
})

app.post("/get_objs", (req,res) => {
    try{
        let inp = req.body;
        let cook = req.cookies;
        // func.log(inp["name"]);
        func.sid(cook,res,()=>{
            obj.loads(inp,cook,res);
        })
    } catch (error) {
        func.log("router objects getting error - "+error);
    }
})

app.post("/get_obj", (req,res) => {
    try{
        let inp = req.body;
        let cook = req.cookies;
        // func.log(inp["name"]);
        func.sid(cook,res,()=>{
            obj.load(inp,cook,res);
        })
    } catch (error) {
        func.log("router single object getting error - "+error);
    }
})


app.get("/get_logs", (req,res) => {
    try{let cook = req.cookies;func.sid(cook,res,()=>{func.logs_file(res);})} 
    catch (error) {func.log("router logs download error - "+error);}
})

// pages
app.get("/reg" , (req,res) =>{
    res.render('reg');
})

app.get("/proj/:name" , (req,res) =>{
    res.render('project',{proj_name:req.params["name"]});
})

app.get("/login" , (req,res) =>{
    res.render('login');
})

app.get("/main", (req,res) =>{
    res.render('main');
});

app.get("/admin", (req,res) =>{
    res.render('admin');
});

// app.get("/test", (req,res) =>{
//     let inp = req.body;
//     let cook = req.cookies;
//     func.sid(cook,res,()=>{
//         console.log("asd");
//     })

// });

app.get('/', (req, res) => {
    if(req.cookies["uuid"] != null){
        res.redirect('main');
    }
    else{
        res.redirect('login');
    }
});

app.all('*', (req, res) => {
    res.status(404).send('<h1>404! Page not</h1> <br> <a href="/">go to main page</a>');
});

app.listen(process.env.PORT || 8080, () => func.log("server for puzzle started UwU"));